Index: oup/releases/0.27a/blubb.txt
===================================================================
--- oup/releases/0.27a/blubb.txt	(revision 8)
+++ 	(revision )
@@ -1,6 +1,0 @@
-___FILEINDEX___.txt
-
-
-TXMP:
-MipMapping: Bit0=an/aus
-ColorDepth: Bit0=??AnimationPic??, Bit1=shade vertex, Bit2=transparency, Bit4=16bit, Bit5=32bit
Index: oup/releases/0.27a/changelog.txt
===================================================================
--- oup/releases/0.27a/changelog.txt	(revision 8)
+++ 	(revision )
@@ -1,76 +1,0 @@
-OniUnPacker v0.27a
-------------------
-+Added MAC-file support
-+Added StructureDefs for ONCCs / TRAMs (thanks to SSG)
-
-OniUnPacker v0.26a
-------------------
-+Fixed some bugs again ;)
-
-OniUnPacker v0.25a
-------------------
-+Fixed some bugs here and there ;)
-+BinEdit/RawEdit: Added keycombo CTRL+S for saving current file
-
-OniUnPacker v0.24a
-------------------
-+RawEdit. Open it by doubleclick on a Raw-Link in the StructureViewer of BinEdit or enter the FileID and the offset of the raw-link in the .dat-file manually
-
-OniUnPacker v0.23a
-------------------
-+Added copy2clipboard functions to ValueViewer (rightclick)
-+Enhanced FileList-filters
-+Added ValueEditor to BinEdit -> StructViewer / ValueViewer (doubleclick on either value field of ValueViewer or StructViewer)
-
-OniUnPacker v0.22a
-------------------
-+Replaced DB-Backend (much faster conversion of levels)
-+Added ValueViewer to BinEdit (decodes selected area as different variable-types)
-
-OniUnPacker v0.21a
-------------------
-+Extractor tool works almost completely (you can't select where the files are stored if you *don't* choose to put them all in one file. They are stored in the root of drive d:)
-+Corrected string-display in the structure viewer of BinEdit (strings are now displayed as a hint of the value-box if you move the mouse over it)
-
-OniUnPacker v0.20a
-------------------
-+? (Forgot what I added here ;) )
-
-OniUnPacker v0.19a
-------------------
-+.dat/.raw -> OUP-Level-DB-Convert basics
-+Extractor tool (not working yet :D )
-
-OniUnPacker v0.18a
-------------------
-+Completely rewritten GUI
-
-OniUnPacker v0.17a
-------------------
-+Binary-editor: Structure-viewer (only TXMP so far)
-
-OniUnPacker v0.16a
-------------------
-+Replaced hex-view-box with a true hex-component
-+Binary-editor for .dat-files
-
-OniUnPacker v0.15a
-------------------
-+Extract menu
-+Changed layout
-
-OniUnPacker v0.14a
-------------------
-+Corrected image-decoder for 32bit images
-+TXMP-Replace: 32bit option (for prevention from quality loss)
-
-OniUnPacker v0.13a
-------------------
-+TXMP-Replace: Transparency option
-+TXMP-Replace: Fading option
-+TXMP-Replace: Overwrites old data if the new fits in that space (to keep the raw as small as possible)
-
-OniUnPacker v0.12a
-------------------
-+TXMP-Replace function (Menu -> Tools -> TXMP Replacer)
-+TXMB-Decoder (export with convert & preview)
Index: oup/releases/0.27a/todo.txt
===================================================================
--- oup/releases/0.27a/todo.txt	(revision 8)
+++ 	(revision )
@@ -1,157 +1,0 @@
-Unit10 unabhängig, funktionsweise wiederherstellen
-Schreibt auch die dat_files[] etc
-Benutzt die *globalen* dat_stream/raw_stream und keine MemCopy
-
-
-ValueViewer: Offset
-
-TXMPReplace: Zugriff über Unit2
-
-
-SELECT [src_id],MIN(datfiles.[name]),SUM(rawmap.[size]) FROM rawmap INNER  JOIN datfiles ON datfiles.[id]=[src_id] GROUP BY [src_id] ORDER BY [src_id] ASC
-
-Extrahier-Ordner-Option (mit Platzhalter für .dat-Name)
-
--HELP.hlp
--About
-
--BinEdit: Zusatzfunktionen wie: Suche, 
--BinEdit: Bild/Menu/Button irgendwas zum speichern
-
--Extractor: Wohin?
-
--FileCompare: Ergebnis=Tabelle, jede Zeile eine differenz-addresse, spalten = werte an addr. für compared files
-
--TXMP-Replace: MultiReplace
-
--Move-Freischalter (Mindestlvl eingabe)
-
--Löschen einer Datei auf die gelinkt wird: Liste der Links und sicherheitsfrage
-
--Filebox-Context: Extract etc
-
--DAT geladen -> Meldung oder sogar "what to do next?"
--SSG: Levels extrahieren?
--Pierre: Wie Char-Anims, Char-Models, Levels extrahieren?
--Language-Files?
--STRG+C auf Dateilisten etc für kopieren des Namens
-
--REPACKING: testen lvl0: 690-collisions.txmp einbauen, script: collisions-zeug
-
-#################################################################
-##########                 File-Types                  ##########
-#################################################################
-(3CLA)
-ABNA
-AGDB
-AGQC
-AGQG
-(AGQM)
-AGQR
-AISA
-AITR
-(AIWA)
-AKAA
-AKBA
-AKBP
-AKDA
-AKEV
-AKOT
-AKVA
-BINA
-CBPI
-CBPM
-CONS
-CRSA
-DOOR
-DPge
-(EDIA)
-ENVP
-FILM
-(FXLR)
-(GMAN)
-HPge
-IDXA
-IGHH
-IGPA
-IGPG
-IGSA
-IGSt
-Impt
-IPge
-KeyI
-M3GA
-M3GM
-(M3TA)
-Mtrl
-(NMSA)
-OBAN
-OBDC
-(OBLS)
-OBOA
-OFGA
-ONCC
-ONCP
-ONCV
-ONFA
-ONGS
-ONIA
-ONLD
-ONLV
-ONMA
-ONOA
-ONSA
-ONSK
-ONTA
-ONVL
-ONWC
-OPge
-OSBD
-OTIT
-OTLF
-PLEA
-PNTA
-PSpc
-PSpL
-PSUI
-QTNA
-(QUDA)
-SNDD
-StNA
-SUBT
-(TMFA)
-(TMRA)
-TRAC
-TRAM
-TRAS
-TRBS
-TRCM
-(TRFT)
-TRGA
-TRGE
-TRIA
-TRIG
-TRMA
-TRSC
-TRTA
-TSFF
-TSFL
-TSFT
-TSGA
-TStr
-TURR
-TXAN
-TXCA
-TXMA
-TXMB
-TXMP
-(TXPC)
-TxtC
-(UUEA)
-(UVDL)
-VCRA
-WMCL
-WMDD
-WMM_
-WMMB
-WPge