Index: oup/current/Tools/Template.dfm
===================================================================
--- oup/current/Tools/Template.dfm	(revision 46)
+++ oup/current/Tools/Template.dfm	(revision 51)
@@ -29,5 +29,5 @@
     AutoSnap = False
     Beveled = True
-    MinSize = 150
+    MinSize = 155
     ExplicitHeight = 473
   end
@@ -62,4 +62,32 @@
         200
         129)
+      object Label2: TLabel
+        Left = 100
+        Top = 105
+        Width = 17
+        Height = 18
+        AutoSize = False
+        Caption = '.'
+        Font.Charset = DEFAULT_CHARSET
+        Font.Color = clWindowText
+        Font.Height = -13
+        Font.Name = 'Tahoma'
+        Font.Style = [fsBold]
+        ParentFont = False
+      end
+      object Label1: TLabel
+        Left = 47
+        Top = 105
+        Width = 17
+        Height = 18
+        AutoSize = False
+        Caption = '-'
+        Font.Charset = DEFAULT_CHARSET
+        Font.Color = clWindowText
+        Font.Height = -13
+        Font.Name = 'Tahoma'
+        Font.Style = [fsBold]
+        ParentFont = False
+      end
       object label_ext: TLabel
         Left = 2
@@ -72,7 +100,7 @@
       end
       object btn_sort_id_asc: TSpeedButton
-        Left = 16
-        Top = 101
-        Width = 23
+        Left = 3
+        Top = 101
+        Width = 20
         Height = 22
         Hint = 'Sort files by id, ascending'
@@ -93,7 +121,7 @@
       end
       object btn_sort_id_desc: TSpeedButton
-        Left = 40
-        Top = 101
-        Width = 23
+        Left = 23
+        Top = 101
+        Width = 20
         Height = 22
         Hint = 'Sort files by id, descending'
@@ -113,7 +141,7 @@
       end
       object btn_sort_name_asc: TSpeedButton
-        Left = 64
-        Top = 101
-        Width = 23
+        Left = 58
+        Top = 101
+        Width = 20
         Height = 22
         Hint = 'Sort files by name, ascending'
@@ -133,7 +161,7 @@
       end
       object btn_sort_name_desc: TSpeedButton
-        Left = 88
-        Top = 101
-        Width = 23
+        Left = 78
+        Top = 101
+        Width = 20
         Height = 22
         Hint = 'Sort files by name, descending'
@@ -153,10 +181,19 @@
       end
       object btn_sort_ext_asc: TSpeedButton
-        Left = 112
-        Top = 101
-        Width = 23
+        Left = 108
+        Top = 101
+        Width = 20
         Height = 22
         Hint = 'Sort files by extension, ascending'
         GroupIndex = 1
+        Glyph.Data = {
+          F6000000424DF600000000000000760000002800000010000000100000000100
+          0400000000008000000000000000000000001000000000000000C0C0C0000000
+          9900990000000000000000000000000000000000000000000000000000000000
+          0000000000000000000000000000000000000000000000000000000000000000
+          0000011111100000300001100010000030000011000000033300000110000003
+          3300000011000033333001000110000030000111111000003000000000000000
+          3000022202220000300000200020000030000022222000003000000202000000
+          3000000222000000300000002000000030000000200000003000}
         ParentShowHint = False
         ShowHint = True
@@ -164,10 +201,19 @@
       end
       object btn_sort_ext_desc: TSpeedButton
-        Left = 136
-        Top = 101
-        Width = 23
+        Left = 128
+        Top = 101
+        Width = 20
         Height = 22
         Hint = 'Sort files by extension, descending'
         GroupIndex = 1
+        Glyph.Data = {
+          F6000000424DF600000000000000760000002800000010000000100000000100
+          0400000000008000000000000000000000001000000000000000C0C0C0000000
+          9900990000000000000000000000000000000000000000000000000000000000
+          0000000000000000000000000000000000000000000000000000000000000000
+          0000022202220000300000200020000030000022222000033300000202000003
+          3300000222000033333000002000000030000000200000003000000000000000
+          3000011111100000300001100010000030000011000000003000000110000000
+          3000000011000000300001000110000030000111111000003000}
         ParentShowHint = False
         ShowHint = True
@@ -187,5 +233,5 @@
         Font.Name = 'Tahoma'
         Font.Style = []
-        ItemHeight = 0
+        ItemHeight = 13
         ParentFont = False
         Sorted = True