Index: oup/current/Tools/Preview.dfm
===================================================================
--- oup/current/Tools/Preview.dfm	(revision 209)
+++ oup/current/Tools/Preview.dfm	(revision 220)
@@ -1,83 +1,84 @@
 inherited Form_Preview: TForm_Preview
-  Caption = 'Preview'
+  Caption = 'Form_Preview'
   OnCreate = FormCreate
-  ExplicitWidth = 500
-  ExplicitHeight = 450
   PixelsPerInch = 96
   TextHeight = 13
-  inherited Splitter1: TSplitter
-    OnMoved = Splitter1Moved
-  end
-  inherited content: TPanel
-    object lbl_notpossible: TLabel
-      Left = 16
-      Top = 56
-      Width = 97
-      Height = 65
-      AutoSize = False
-      Caption = 'No preview possible for this filetype'
-      Font.Charset = DEFAULT_CHARSET
-      Font.Color = clWindowText
-      Font.Height = -16
-      Font.Name = 'Tahoma'
-      Font.Style = []
-      ParentFont = False
-      Visible = False
-      WordWrap = True
+  inherited panel_basecontent: TPanel
+    inherited splitter_content: TSplitter
+      OnMoved = Splitter1Moved
     end
-    object img: TImage
-      AlignWithMargins = True
-      Left = 3
-      Top = 23
-      Width = 277
-      Height = 397
-      Align = alClient
-      ExplicitLeft = 0
-      ExplicitTop = 20
-      ExplicitWidth = 313
-      ExplicitHeight = 453
-    end
-    object panel_buttons: TPanel
-      Left = 0
-      Top = 0
-      Width = 283
-      Height = 20
-      Align = alTop
-      BevelOuter = bvNone
-      TabOrder = 0
-      Visible = False
-      OnResize = panel_buttonsResize
-      object btn_dec: TButton
+    inherited panel_content: TPanel
+      object img: TImage
+        AlignWithMargins = True
+        Left = 3
+        Top = 23
+        Width = 384
+        Height = 506
+        Align = alClient
+        ExplicitLeft = 0
+        ExplicitTop = 20
+        ExplicitWidth = 313
+        ExplicitHeight = 453
+      end
+      object lbl_notpossible: TLabel
+        Left = 16
+        Top = 56
+        Width = 97
+        Height = 65
+        AutoSize = False
+        Caption = 'No preview possible for this filetype'
+        Font.Charset = DEFAULT_CHARSET
+        Font.Color = clWindowText
+        Font.Height = -16
+        Font.Name = 'Tahoma'
+        Font.Style = []
+        ParentFont = False
+        Visible = False
+        WordWrap = True
+      end
+      object panel_buttons: TPanel
         Left = 0
         Top = 0
-        Width = 20
+        Width = 390
         Height = 20
-        Caption = '-'
-        Enabled = False
+        Align = alTop
+        BevelOuter = bvNone
         TabOrder = 0
-        OnClick = btn_decClick
-      end
-      object btn_startstop: TButton
-        Left = 21
-        Top = 0
-        Width = 80
-        Height = 20
-        Caption = 'Stop automatic'
-        TabOrder = 1
-        OnClick = btn_startstopClick
-      end
-      object btn_inc: TButton
-        Left = 102
-        Top = 0
-        Width = 20
-        Height = 20
-        Caption = '+'
-        Enabled = False
-        TabOrder = 2
-        OnClick = btn_incClick
+        Visible = False
+        OnResize = panel_buttonsResize
+        ExplicitWidth = 283
+        object btn_dec: TButton
+          Left = 0
+          Top = 0
+          Width = 20
+          Height = 20
+          Caption = '-'
+          Enabled = False
+          TabOrder = 0
+          OnClick = btn_decClick
+        end
+        object btn_startstop: TButton
+          Left = 21
+          Top = 0
+          Width = 80
+          Height = 20
+          Caption = 'Stop automatic'
+          TabOrder = 1
+          OnClick = btn_startstopClick
+        end
+        object btn_inc: TButton
+          Left = 102
+          Top = 0
+          Width = 20
+          Height = 20
+          Caption = '+'
+          Enabled = False
+          TabOrder = 2
+          OnClick = btn_incClick
+        end
       end
     end
   end
-  object timer: TTimer [3]
+  object timer: TTimer
     Enabled = False
     OnTimer = timerTimer