Index: oup/current/Main.dfm
===================================================================
--- oup/current/Main.dfm	(revision 222)
+++ oup/current/Main.dfm	(revision 227)
@@ -139,4 +139,8 @@
           OnClick = menu_metaClick
         end
+        object menu_filemanager: TTBItem
+          Caption = '&FileManager'
+          OnClick = menu_filemanagerClick
+        end
         object menu_filecompare: TTBItem
           Caption = '&File compare ...'
@@ -198,4 +202,9 @@
             Checked = True
             OnClick = menu_view_toolbarClick
+          end
+          object menu_view_toolbar_tools: TTBItem
+            Caption = '&Toolbar (Tools)'
+            Checked = True
+            OnClick = menu_view_toolbar_toolsClick
           end
           object menu_view_statusbar: TTBItem
@@ -216,12 +225,12 @@
       end
     end
-    object Toolbar: TTBToolbar
+    object Toolbar_main: TTBToolbar
       Left = 0
       Top = 23
-      Caption = 'Toolbar'
+      Caption = 'Toolbar_main'
       DragHandleStyle = dhDouble
       Images = MenuImages
       TabOrder = 1
-      OnDockChanged = ToolbarDockChanged
+      OnDockChanged = Toolbar_mainDockChanged
       object tbOpen: TTBItem
         Caption = 'Open .dat'
@@ -252,68 +261,13 @@
       object TBSeparatorItem1: TTBSeparatorItem
       end
-      object tb_preview: TTBItem
-        Caption = 'Preview'
-        DisplayMode = nbdmImageAndText
-        Enabled = False
-        ImageIndex = 4
-        OnClick = menu_previewClick
-      end
-      object tb_datedit: TTBItem
-        Caption = 'DatEditor'
-        DisplayMode = nbdmImageAndText
-        Enabled = False
-        ImageIndex = 5
-        OnClick = menu_bineditClick
-      end
-      object tb_rawedit: TTBItem
-        Caption = 'RawEditor'
-        DisplayMode = nbdmImageAndText
-        Enabled = False
-        ImageIndex = 6
-        OnClick = menu_raweditClick
-      end
-      object tb_txmpreplacer: TTBItem
-        Caption = 'TXMP replacer'
-        DisplayMode = nbdmImageAndText
-        Enabled = False
-        ImageIndex = 7
-        OnClick = menu_txmpreplaceClick
-      end
-      object tb_extractor: TTBItem
-        Caption = 'File extractor'
-        DisplayMode = nbdmImageAndText
-        Enabled = False
-        ImageIndex = 8
-        OnClick = menu_extractorClick
-      end
-      object tb_meta: TTBItem
-        Caption = 'MetaEditor'
-        DisplayMode = nbdmImageAndText
-        Enabled = False
-        ImageIndex = 11
-        OnClick = menu_metaClick
-      end
-      object tb_compare: TTBItem
-        Caption = 'File compare'
-        DisplayMode = nbdmImageAndText
-        Enabled = False
-        ImageIndex = 10
-        OnClick = menu_filecompareClick
-      end
-      object tb_structure: TTBItem
-        Caption = 'Level structure'
-        DisplayMode = nbdmImageAndText
-        Enabled = False
-        ImageIndex = 12
-      end
     end
     object MDIToolbar: TTBToolbar
-      Left = 0
+      Left = 29
       Top = 49
       Caption = 'MDIToolbar'
       DockableTo = [dpTop, dpBottom]
       DockMode = dmCannotFloat
-      DockPos = 0
-      DockRow = 2
+      DockPos = 29
+      DockRow = 3
       DragHandleStyle = dhDouble
       TabOrder = 2
@@ -341,4 +295,73 @@
         OnMouseMove = MDITabMouseMove
         OnMouseUp = MDITabMouseUp
+      end
+    end
+    object Toolbar_tools: TTBToolbar
+      Left = 328
+      Top = 23
+      Caption = 'Toolbar'
+      DockPos = 334
+      DragHandleStyle = dhDouble
+      Images = MenuImages
+      TabOrder = 3
+      OnDockChanged = Toolbar_mainDockChanged
+      object tb_preview: TTBItem
+        Caption = 'Preview'
+        DisplayMode = nbdmImageAndText
+        Enabled = False
+        ImageIndex = 4
+        OnClick = menu_previewClick
+      end
+      object tb_datedit: TTBItem
+        Caption = 'DatEditor'
+        DisplayMode = nbdmImageAndText
+        Enabled = False
+        ImageIndex = 5
+        OnClick = menu_bineditClick
+      end
+      object tb_rawedit: TTBItem
+        Caption = 'RawEditor'
+        DisplayMode = nbdmImageAndText
+        Enabled = False
+        ImageIndex = 6
+        OnClick = menu_raweditClick
+      end
+      object tb_txmpreplacer: TTBItem
+        Caption = 'TXMP replacer'
+        DisplayMode = nbdmImageAndText
+        Enabled = False
+        ImageIndex = 7
+        OnClick = menu_txmpreplaceClick
+      end
+      object tb_extractor: TTBItem
+        Caption = 'File extractor'
+        DisplayMode = nbdmImageAndText
+        Enabled = False
+        ImageIndex = 8
+        OnClick = menu_extractorClick
+      end
+      object tb_meta: TTBItem
+        Caption = 'MetaEditor'
+        DisplayMode = nbdmImageAndText
+        Enabled = False
+        ImageIndex = 11
+        OnClick = menu_metaClick
+      end
+      object tb_filemanager: TTBItem
+        Caption = 'FileManager'
+        OnClick = menu_filemanagerClick
+      end
+      object tb_compare: TTBItem
+        Caption = 'File compare'
+        DisplayMode = nbdmImageAndText
+        Enabled = False
+        ImageIndex = 10
+        OnClick = menu_filecompareClick
+      end
+      object tb_structure: TTBItem
+        Caption = 'Level structure'
+        DisplayMode = nbdmImageAndText
+        Enabled = False
+        ImageIndex = 12
       end
     end